package com.loafle.overflow.spring;

import org.springframework.beans.factory.config.PropertyPlaceholderConfigurer;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.PropertySource;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;

/**
 * Created by insanity on 17. 6. 13.
 */
@Configuration
@ComponentScan(basePackages = {"com.loafle.overflow"}, excludeFilters = @ComponentScan.Filter({Configuration.class}))
@PropertySource({"classpath:database.properties","classpath:mail.properties"})
public class AppConfig {
    @Bean
    public static PropertyPlaceholderConfigurer propertyPlaceholderConfigurer() {
        PropertyPlaceholderConfigurer ppc = new PropertyPlaceholderConfigurer();
//        ppc.setLocation(new ClassPathResource("database.properties"));
        ppc.setLocations(new Resource[] {
                new ClassPathResource("database.properties"),
                new ClassPathResource("mail.properties")
        });
        ppc.setIgnoreUnresolvablePlaceholders(true);

        return ppc;
    }
}
