package com.loafle.overflow.module.infra.service;

import com.loafle.overflow.module.infra.model.Infra;
import com.loafle.overflow.module.meta.model.MetaInfraType;
import com.loafle.overflow.module.probe.model.Probe;
import com.loafle.overflow.module.target.model.Target;
import com.loafle.overflow.spring.AppConfig;
import com.loafle.overflow.spring.JdbcConfiguration;
import com.loafle.overflow.spring.MailConfiguration;
import org.codehaus.jackson.map.ObjectMapper;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

/**
 * Created by snoop on 17. 7. 27.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfig.class, JdbcConfiguration.class, MailConfiguration.class})
public class InfraServiceTest {

    @Autowired
    private InfraService infraService;

    @Test
    public void regist() throws Exception {

       long id =registInfra(1,1);
        Assert.assertNotEquals(id, 0);

        id =registInfra(3,1);
        Assert.assertNotEquals(id, 0);

        id =registInfra(2,1);
        Assert.assertNotEquals(id, 0);



    }

    public long registInfra(int type, int childId) {
        MetaInfraType metaInfraType = new MetaInfraType();
        metaInfraType.setId(type);

        Infra infra = new Infra();
        infra.setInfraType(metaInfraType);
        infra.setChildId(childId);



        Probe probe = new Probe();
        probe.setId(1);

        Target target = new Target();
        target.setId(1);

        infra.setProbe(probe);
        infra.setTarget(target);

        this.infraService.regist(infra);

        return infra.getId();
    }

    @Test
    public void read() throws Exception {

        Infra infra = this.infraService.read(3);

        ObjectMapper objectMapper = new ObjectMapper();
        String json = objectMapper.writeValueAsString(infra);

        System.out.println(json);
    }

}